# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2013-05-14.      #
#                                                           #
# Bindings Version 2.0.7                                    #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generator git on tinkerforge.com                   #
#############################################################

module Tinkerforge
  # Device for reading temperatures from Pt100 or Pt1000 sensors
  class BrickletPTC < Device
    DEVICE_IDENTIFIER = 226 # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletPTC#set_temperature_callback_period. The parameter is the temperature
    # of the sensor.
    # 
    # CALLBACK_TEMPERATURE is only triggered if the temperature has changed since the
    # last triggering.
    CALLBACK_TEMPERATURE = 13

    # This callback is triggered when the threshold as set by
    # BrickletPTC#set_temperature_callback_threshold is reached.
    # The parameter is the temperature of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletPTC#set_debounce_period.
    CALLBACK_TEMPERATURE_REACHED = 14

    # This callback is triggered periodically with the period that is set by
    # BrickletPTC#set_resistance_callback_period. The parameter is the resistance
    # of the sensor.
    # 
    # CALLBACK_RESISTANCE is only triggered if the resistance has changed since the
    # last triggering.
    CALLBACK_RESISTANCE = 15

    # This callback is triggered when the threshold as set by
    # BrickletPTC#set_resistance_callback_threshold is reached.
    # The parameter is the resistance of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletPTC#set_debounce_period.
    CALLBACK_RESISTANCE_REACHED = 16

    FUNCTION_GET_TEMPERATURE = 1 # :nodoc:
    FUNCTION_GET_RESISTANCE = 2 # :nodoc:
    FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 4 # :nodoc:
    FUNCTION_SET_RESISTANCE_CALLBACK_PERIOD = 5 # :nodoc:
    FUNCTION_GET_RESISTANCE_CALLBACK_PERIOD = 6 # :nodoc:
    FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 7 # :nodoc:
    FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 8 # :nodoc:
    FUNCTION_SET_RESISTANCE_CALLBACK_THRESHOLD = 9 # :nodoc:
    FUNCTION_GET_RESISTANCE_CALLBACK_THRESHOLD = 10 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 11 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 12 # :nodoc:
    FUNCTION_SET_NOISE_REJECTION_FILTER = 17 # :nodoc:
    FUNCTION_GET_NOISE_REJECTION_FILTER = 18 # :nodoc:
    FUNCTION_IS_SENSOR_CONNECTED = 19 # :nodoc:
    FUNCTION_SET_WIRE_MODE = 20 # :nodoc:
    FUNCTION_GET_WIRE_MODE = 21 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    FILTER_OPTION_50HZ = 0 # :nodoc:
    FILTER_OPTION_60HZ = 1 # :nodoc:
    WIRE_MODE_2OR4 = 0 # :nodoc:
    WIRE_MODE_3 = 1 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_RESISTANCE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RESISTANCE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_RESISTANCE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_RESISTANCE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_RESISTANCE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[CALLBACK_TEMPERATURE] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_TEMPERATURE_REACHED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_RESISTANCE] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_RESISTANCE_REACHED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[FUNCTION_SET_NOISE_REJECTION_FILTER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_NOISE_REJECTION_FILTER] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_IS_SENSOR_CONNECTED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WIRE_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_WIRE_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_TEMPERATURE] = 'l'
      @callback_formats[CALLBACK_TEMPERATURE_REACHED] = 'l'
      @callback_formats[CALLBACK_RESISTANCE] = 'S'
      @callback_formats[CALLBACK_RESISTANCE_REACHED] = 'S'
    end

    # TODO
    # 
    # If you want to get the temperature periodically, it is recommended 
    # to use the callback CALLBACK_TEMPERATURE and set the period with 
    # BrickletPTC#set_temperature_callback_period.
    def get_temperature
      send_request(FUNCTION_GET_TEMPERATURE, [], '', 4, 'l')
    end

    # TODO
    # 
    # If you want to get the resistance periodically, it is recommended 
    # to use the callback CALLBACK_RESISTANCE and set the period with 
    # BrickletPTC#set_resistance_callback_period.
    def get_resistance
      send_request(FUNCTION_GET_RESISTANCE, [], '', 2, 'S')
    end

    # Sets the period in ms with which the CALLBACK_TEMPERATURE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # CALLBACK_TEMPERATURE is only triggered if the temperature has changed since the
    # last triggering.
    # 
    # The default value is 0.
    def set_temperature_callback_period(period)
      send_request(FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickletPTC#set_temperature_callback_period.
    def get_temperature_callback_period
      send_request(FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_RESISTANCE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # CALLBACK_RESISTANCE is only triggered if the resistance has changed since the
    # last triggering.
    # 
    # The default value is 0.
    def set_resistance_callback_period(period)
      send_request(FUNCTION_SET_RESISTANCE_CALLBACK_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickletPTC#set_resistance_callback_period.
    def get_resistance_callback_period
      send_request(FUNCTION_GET_RESISTANCE_CALLBACK_PERIOD, [], '', 4, 'L')
    end

    # Sets the thresholds for the CALLBACK_TEMPERATURE_REACHED callback. 
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0).
    def set_temperature_callback_threshold(option, min, max)
      send_request(FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, [option, min, max], 'k l l', 0, '')
    end

    # Returns the threshold as set by BrickletPTC#set_temperature_callback_threshold.
    def get_temperature_callback_threshold
      send_request(FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, [], '', 9, 'k l l')
    end

    # Sets the thresholds for the CALLBACK_RESISTANCE_REACHED callback. 
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0).
    def set_resistance_callback_threshold(option, min, max)
      send_request(FUNCTION_SET_RESISTANCE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 0, '')
    end

    # Returns the threshold as set by BrickletPTC#set_resistance_callback_threshold.
    def get_resistance_callback_threshold
      send_request(FUNCTION_GET_RESISTANCE_CALLBACK_THRESHOLD, [], '', 5, 'k S S')
    end

    # Sets the period in ms with which the threshold callback
    # 
    #  CALLBACK_TEMPERATURE_REACHED, CALLBACK_RESISTANCE_REACHED
    # 
    # is triggered, if the threshold
    # 
    #  BrickletPTC#set_temperature_callback_threshold, BrickletPTC#set_resistance_callback_threshold
    # 
    # keeps being reached.
    # 
    # The default value is 100.
    def set_debounce_period(debounce)
      send_request(FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 0, '')
    end

    # Returns the debounce period as set by BrickletPTC#set_debounce_period.
    def get_debounce_period
      send_request(FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 4, 'L')
    end

    # TODO: Setting noise rejection filter frequency (50 or 60hz), default 50hz).
    def set_noise_rejection_filter(filter)
      send_request(FUNCTION_SET_NOISE_REJECTION_FILTER, [filter], 'C', 0, '')
    end

    # Returns the noise rejection filter option as set by 
    # BrickletPTC#set_noise_rejection_filter
    def get_noise_rejection_filter
      send_request(FUNCTION_GET_NOISE_REJECTION_FILTER, [], '', 1, 'C')
    end

    # Returns *true* if the sensor is connected correctly. 
    # 
    # If this function
    # returns *false*, there is either no pt100 or pt1000 sensor connected, 
    # the sensor is connect incorrectly or the sensor itself is faulty.
    def is_sensor_connected
      send_request(FUNCTION_IS_SENSOR_CONNECTED, [], '', 1, '?')
    end

    # TODO: Default: 1 (3 wire)
    def set_wire_mode(mode)
      send_request(FUNCTION_SET_WIRE_MODE, [mode], 'C', 0, '')
    end

    # Returns the wire mode as set by BrickletPTC#set_wire_mode
    def get_wire_mode
      send_request(FUNCTION_GET_WIRE_MODE, [], '', 1, 'C')
    end

    # Returns the UID, the UID where the Bricklet is connected to, 
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifiers can be found :ref:`here <device_identifier>`.
    # 
    # .. versionadded:: 2.0.0~(Plugin)
    def get_identity
      send_request(FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S')
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
